C   ###################################################################
C   ## E x e r c i s e  T h r e e: model answer                      ##
C   ################################################################### 


C   ####################################################################
C   ## The procedure "total_exchange_array" performs an all-to-all    ##
C   ## total exchange of an array "src" of size "src_size" held       ##
C   ## locally on each process. The value of "src_array"  may be      ##
C   ## different on each process. The effect of the procedure is each ##
C   ## process receives a copy of each other processes version of src,##
C   ## which  are concatendated together, in process id order, into   ##
C   ## the array "dst". The size of "dst", is "dst_array". However,   ##
C   ## exit from the procedure, the reference parameter dst_size is   ##
C   ## changed to record the actual size of the concatenated arrays.  ##
C   ## An error is raised if this is larger than the value of         ##
C   ## "dst_array" passed as an argument to the procedure.            ##
C   #################################################################### 

        SUBROUTINE total_exchange_array(src,src_size,dst,dst_size)
	  INCLUDE 'fbsp.h'
          INTEGER src(*),dst(*),src_size,dst_size
        END

C   ###################################################################
C   ## The main procedure starts as many processes as possible, and  ##
C   ## then performs a total exchange of the ID's of each prcocess.  ##
C   ###################################################################

	PROGRAM MAIN
	INCLUDE 'fbsp.h'
        INTEGER MAXP,STARTSIZE,SIZE,MAX_SIZE
	PARAMETER (MAXP=1024,STARTSIZE=4)
        INTEGER src(STARTSIZE+MAXP), dst((STARTSIZE+MAXP)*MAXP)
        DOUBLE PRECISION delta
        
        CALL bspbegin(bspnprocs())

          SIZE     = STARTSIZE + bsppid()
          MAX_SIZE = (bspnprocs()+SIZE)*bspnprocs()
          WRITE (*,*) 'Allocating ',SIZE,' elements on process ',bsppid()
          DO i=1,SIZE
            src(i) = bsppid()
          END DO
          delta = bspdtime()
          CALL total_exchange_array(src,SIZE,dst,MAX_SIZE)

          DO i = 0,bspnprocs()
            IF (bsppid() .EQ. i) THEN
              WRITE (*,*) 'On process ',i , ' dst = ',
     +                    (dst(j),j=1,MAX_SIZE)
            END IF
            CALL bspsync()
          END DO

	CALL bspend()
	END
