C   ###################################################################
C   ## E x e r c i s e  T w o: model answer                          ##
C   ################################################################### 


C   ####################################################################
C   ## The procedure "total_exchange_array" performs an all-to-all    ##
C   ## total exchange of an array "src" of size n held locally on     ##
C   ## each process. The value of n _must_ be the same on all         ##
C   ## processes. The result of the procedure is that each process    ##
C   ## receives a copy of each other processes version of src, which  ##
C   ## are then concatendated together, in process id order, into the ##
C   ## array "dst". The size of the resulting array "dst", must       ##
C   ## therefore contain at least bsp_nprocs()*n integers.            ##
C   #################################################################### 

        SUBROUTINE total_exchange_array(src,dst,n)
	  INCLUDE 'fbsp.h'
          INTEGER src(*),dst(*),n
        END


C   ###################################################################
C   ## The main procedure starts as many processes as possible, and  ##
C   ## then performs a total exchange of the ID's of each prcocess.  ##
C   ###################################################################

	PROGRAM MAIN
	INCLUDE 'fbsp.h'
        INTEGER MAXP,SIZE
	PARAMETER (MAXP=1024,SIZE=4)
        INTEGER src(SIZE), dst(SIZE*MAXP)
        DOUBLE PRECISION delta
        
        CALL bspbegin(bspnprocs())

          DO i=1,SIZE
            src(i) = bsppid()
          END DO
          delta = bspdtime()
          CALL total_exchange_array(src,dst,SIZE)

          DO i = 0,bspnprocs()
            IF (bsppid() .EQ. i) THEN
              WRITE (*,*) 'On process ',i , ' dst = ',
     +                    (dst(j),j=1,(SIZE*bspnprocs()))
            END IF
            CALL bspsync()
          END DO

	CALL bspend()
	END
