C   ###################################################################
C   ## E x e r c i s e  O n e: model answer                          ##
C   ################################################################### 

C   ###################################################################
C   ## The procedure "total_exchange_int" performs an all-to-all     ##
C   ## total exchange of a single integer held locally on each       ##
C   ## process. The result of the procedure is that the array xs will##
C   ## be overwritten with P integers, such that the i^th            ##
C   ## element of the array contains the integer x that was passed   ##
C   ## as an argument to the function on process i.                  ##
C   ################################################################### 

        SUBROUTINE total_exchange_int(x,xs)
	  INCLUDE 'fbsp.h'
          INTEGER x,xs(*)
          INTEGER SIZEINT
          PARAMETER (SIZEINT=4)
          INTEGER i
        
          CALL bsppushreg(xs,bspnprocs()*SIZEINT)
          CALL bspsync()

          DO i=0,bspnprocs()-1
            CALL bspput(i,x,xs,bsppid()*SIZEINT,SIZEINT)
          END DO
          CALL bspsync()
          CALL bsppopreg(xs)
        END


C   ###################################################################
C   ## The main procedure starts as many processes as possible, and  ##
C   ## then performs a total exchange of the ID's of each prcocess.  ##
C   ###################################################################

	PROGRAM MAIN
	INCLUDE 'fbsp.h'
        INTEGER MAXP
	PARAMETER (MAXP=1024)
        INTEGER val , vals(MAXP)
        
        CALL bspbegin(bspnprocs())

          val   = bsppid()
          CALL total_exchange_int(val,vals)

          DO i = 0,bspnprocs()
            IF (bsppid() .EQ. i) THEN
              WRITE (*,*) 'On process ',i , ' val = ',
     +                    (vals(j),j=1,bspnprocs())  
            END IF
            CALL bspsync()
          END DO

	CALL bspend()
	END
